Description

C++ compilation takes quite some time at the moment. 
Highly desirable to be faster.

Check (for instance) use of forward-declarations and 
the pimpl idiom ?

Associated revisions
Revision 85d531e0 - 07/27/2011 08:52 PM - J. Moringen
Split Factory::createConnectors into 3 methods in src/rsb/Factory.{h,cpp}
refs #424 (should speed up compilation)
refs #447 (may fix the issue)
    -  src/rsb/Factory.{h,cpp}: split template method

  Factory::createConnectors into non-template methods
  Factory::createInPullConnectors, Factory::createInPushConnectors and
  Factory::createOutConnectors; changed
  create{Listener,Reader,Informer} accordingly; moved includes and
  pairsToMap to Factory.cpp

History
#1 - 09/12/2011 04:54 PM - J. Wienke

I would highly appreciate using pimpl. What do others think about this?

#2 - 09/12/2011 04:55 PM - J. Wienke

This also provides a bit more of ABI / API stability.

#3 - 09/12/2011 09:18 PM - S. Wrede

Lets stick to the procedure also suggested in the given reference:

Therefore, it's always best to experiment with a few key-classes in a project and learn how this affects your project's build-time.

#4 - 10/18/2011 02:22 PM - J. Wienke

I will do this. Waiting for the windows build is so annoying.
http://www.devx.com/cplus/Article/28105


#5 - 10/18/2011 02:23 PM - J. Wienke
- Status changed from New to In Progress

#6 - 10/18/2011 05:19 PM - J. Wienke
- Assignee set to J. Wienke

r2884 reduced compile time from 7:16 to 5:25 on my laptop, only one build job. Please note that this may break external clients as some things in the
public API are now forward-declared.

A major part of the compile time is used by examples and unit tests. Here, gtest is very expensive.

#7 - 10/18/2011 05:38 PM - J. Wienke

Switching off tests and examples this reduces from 3:57 to 2:43.

#8 - 10/19/2011 10:47 AM - J. Wienke
- Target version set to 0.5
- % Done changed from 0 to 40

Do you see any other possibilities for speed up now which are cheap to implement?

#9 - 10/20/2011 04:01 PM - J. Wienke
- Status changed from In Progress to Resolved
- % Done changed from 40 to 100

This first speed-up must be enough for version 0.5. If more is required, please add another issue.
